#include "spawn.h"

#include "..\algorithms.h"
#include "md5.h"

extern class TeamBox TBox;

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
				sendPrivate(p, "!freqkill !freqreset");
			}
		case OP_Player:
			{	// Player-level commands
				sendPrivate(p, "!about");
				sendPrivate(p, "!freg !funreg !freqs !fname !fjoin !fkick !fpass !fsquad !fgrant !fwelc !finv");
				sendPrivate(p, "Send !help <command> for details. Registering too many freqs for no reason will be punished!");
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
			if (c->checkParam("owner") || c->checkParam("all"))
			{
			}
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if (c->checkParam("sop") || c->checkParam("all"))
			{
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->checkParam("smod") || c->checkParam("all"))
			{
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("mod") || c->checkParam("all"))
			{
			}
		}
	case OP_Limited:
		{	// Limited-level commands
			if (c->checkParam("freqkill"))
			{
				sendPrivate(p, "!freqkill");
				sendPrivate(p, "Syntax: !freqkill <owner name>");
				sendPrivate(p, "Deletes all freqs owned by the player");
			}
		}
	case OP_Player:
		{	// Player-level commands
			if (c->checkParam("about"))
			{
				sendPrivate(p, "!about");
				sendPrivate(p, "Syntax: !about");
				sendPrivate(p, "Displays info about bot");
			}
			else if (c->checkParam("freg"))
			{
				sendPrivate(p, "!freg");
				sendPrivate(p, "Syntax: !freg <freq>:<password>");
				sendPrivate(p, "Registers a freq in your name. Only people who you invite or who know the password can join it");
				sendPrivate(p, "You can also set it so only a certain squad can join it");
				sendPrivate(p, "Freq must be at least 100");
				String s = "You can register a maximum of ";
				s += MaxOwnedFreqs;
				s += " freqs";
				sendPrivate(p, s.msg);
			}
			else if (c->checkParam("funreg"))
			{
				sendPrivate(p, "!funreg");
				sendPrivate(p, "Syntax: !funreg <freq>");
				sendPrivate(p, "Unregisters a freq that you own");
				sendPrivate(p, "Only the owner or an operator can unregister a freq");
			}
			else if (c->checkParam("freqs"))
			{
				sendPrivate(p, "!freqs");
				sendPrivate(p, "Syntax: !freqs");
				sendPrivate(p, "Displays all registered freqs and their details");
			}
			else if (c->checkParam("fname"))
			{
				sendPrivate(p, "!fname");
				sendPrivate(p, "Syntax: !fname <freq>:<name>");
				sendPrivate(p, "Sets the name of the freq");
			}
			else if (c->checkParam("fjoin"))
			{
				sendPrivate(p, "!fjoin");
				sendPrivate(p, "Syntax: !fjoin <freq>:<password>");
				sendPrivate(p, "Invites you to the specified freq");
			}
			else if (c->checkParam("fkick"))
			{
				sendPrivate(p, "!fkick");
				sendPrivate(p, "Syntax: !fkick <freq>:<player name>");
				sendPrivate(p, "Kicks a player from your freq");
			}
			else if (c->checkParam("fpass"))
			{
				sendPrivate(p, "!fpass");
				sendPrivate(p, "Syntax: !fpass <freq>:<password>");
				sendPrivate(p, "Changes the password of a freq");
			}
			else if (c->checkParam("fsquad"))
			{
				sendPrivate(p, "!fsquad");
				sendPrivate(p, "Syntax: !fsquad <freq>:<squad>");
				sendPrivate(p, "Allows all members of a squad to join the freq");
			}
			else if (c->checkParam("fgrant"))
			{
				sendPrivate(p, "!fgrant");
				sendPrivate(p, "Syntax: !fgrant <freq>:<player name>");
				sendPrivate(p, "Gives ownership of a freq to another player");
				sendPrivate(p, "The other player must be in the arena");
			}
			else if (c->checkParam("fwelc"))
			{
				sendPrivate(p, "!fwelc");
				sendPrivate(p, "Syntax: !fwelc <freq>:<welcome message>");
				sendPrivate(p, "Changed the message said when a player joins a freq");
				sendPrivate(p, "Macros: %name%   - Name of the player");
				sendPrivate(p, "        %fnum%   - Freq number");
				sendPrivate(p, "        %fname%  - Freq name");
				sendPrivate(p, "        %fsquad% - The squad allowed on the freq");
				sendPrivate(p, "        %sq%     - Squad of the player");
				sendPrivate(p, "        %points% - Points of player");
			}
			else if (c->checkParam("finv"))
			{
				sendPrivate(p, "!finv");
				sendPrivate(p, "Syntax: !finv <freq>:<player name>");
				sendPrivate(p, "Invites a player to a freq");
				sendPrivate(p, "The player must be in the arena");
			}
			else if (c->checkParam("freqreset"))
			{
				sendPrivate(p, "!freqreset");
				sendPrivate(p, "Syntax: !freqreset");
				sendPrivate(p, "Clears the freq database");
			}
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
			if (c->check("freqkill"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				TeamEntry *t;
				while (t = TBox.FindTeam(c->final))
					TBox.RemoveTeam(t);

				sendPrivate(p, "All freqs owned by that used have been deleted");
			}
			else if (c->check("freqreset"))
			{
				TBox.Box.clear();
				TBox.InviteBox.clear();

				sendPrivate(p, "Freq database cleared");
			}
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about"))
			{
				String s;
				s = "\"TM Vex\" 1.10 compiled on ";
				s += __DATE__;
				s += " ";
				s += __TIME__;

				sendPrivate(p, s.msg);

				s = "DLL core version: ";
				s += (int)CORE_MAJOR_VERSION;
				s += ".";
				s += (int)CORE_MINOR_VERSION;

				sendPrivate(p, s.msg);

				sendPrivate(p, "Made by SOS(aarkesos@subdimension.com) in cooperation with Continuum Central Union(ccu.continuum-central.com). Well not really, but they deserve the ad :p");
			}
			else if (c->check("freg"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, pass;
				pass = c->final;

				Uint32 i = pass.firstInstanceOf(':');

				if (i == -1 || i == pass.len - 1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = pass.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				if (TBox.CountOwned(p->name) >= MaxOwnedFreqs)
				{
					sendPrivate(p, "You already own too many freqs");
					return;
				}

				i = freq.toInteger();

				if (i >= settings->MaxFrequency || i < 100 || i == SpecFreq)
				{
					sendPrivate(p, "Invalid freq");
					return;
				}

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (t)
				{
					sendPrivate(p, "That freq is already registered");
					return;
				}

				Uint32 pw = MD5Hash(pass.msg, pass.len);

				t = TBox.AddTeam((Uint16)i, p->name, pw);
				time(&t->LastUsed);

				sendPrivate(p, "Freq registered");
			}
			else if (c->check("funreg"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				if (!isNumeric(c->final))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				TeamEntry *t = TBox.FindTeam((Uint16)getInteger(c->final, 10));

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!p->access && !CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				sendTeamPrivate(t->Freq, "This freq is no longer owned");

				TBox.RemoveTeam(t);

				sendPrivate(p, "Freq unregistered");
			}
			else if (c->check("freqs"))
			{
				if (!TBox.Box.total)
				{
					sendPrivate(p, "There are no registered freqs");
					return;
				}

				_listnode <TeamEntry> *parse = TBox.Box.head;
				while (parse)
				{
					String s;
					s = parse->item->Freq;
					s = s.rfill(5);
					s += "[";
					s += parse->item->Owner;
					if (parse->item->AllowedSquad[0])
					{
						s += "][Squad: ";
						s += parse->item->AllowedSquad;
					}

					s += "]";
					s = s.rfill(32);

					if (parse->item->Name[0])
					{
						s += " - ";
						s += parse->item->Name;
					}

					if (p->access)
					{
						s += " [LastUsed: ";

						tm *CD = localtime(&parse->item->LastUsed);
						s += getDateString(CD);
						s += " ";
						s += getTimeString(CD);

						s += "]";
					}

					sendPrivate(p, s.msg);

					parse = parse->next;
				}
			}
			else if (c->check("fname"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, name;
				name = c->final;

				Uint32 i = name.firstInstanceOf(':');

				if (i == -1 || i == name.len - 1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = name.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				ZeroMemory(t->Name, 32);
				memcpy(t->Name, name.msg, min(name.len, 31));

				sendPrivate(p, "Freq name changed");
			}
			else if (c->check("fjoin"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, pass;
				pass = c->final;

				Uint32 i = pass.firstInstanceOf(':');

				if (i == -1 || i == pass.len - 1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = pass.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (t->Password != MD5Hash(pass.msg, pass.len))
				{
					sendPrivate(p, "Invalid password");
					return;
				}

				TBox.AddInvite(t->Freq, p->name);

				String s;
				s = "You have ";
				s += InviteExpireSeconds;
				s += " seconds to join the freq. After that you must !fjoin again";
				sendPrivate(p, s.msg);
			}
			else if (c->check("fkick"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, name;
				name = c->final;

				Uint32 i = name.firstInstanceOf(':');

				if (i == -1 || i == name.len - 1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = name.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				_listnode <Player> *parse = playerlist->head;
				while (parse)
				{
					if (name == parse->item->name)
					{
						if (parse->item->team != i)
						{
							sendPrivate(p, "The player is not on the freq");
							return;
						}

						sendPrivate(parse->item, "You were kicked from the freq");
						sendPrivate(parse->item, "*setfreq 0");

						return;
					}

					parse = parse->next;
				}

				sendPrivate(p, "Player not found");
			}
			else if (c->check("fpass"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, pass;
				pass = c->final;

				Uint32 i = pass.firstInstanceOf(':');

				if (i == -1 || i == pass.len - 1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = pass.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				t->Password = MD5Hash(pass.msg, pass.len);

				sendPrivate(p, "Freq password changed");
			}
			else if (c->check("fsquad"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, name;
				name = c->final;

				Uint32 i = name.firstInstanceOf(':');

				if (i == -1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = name.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				ZeroMemory(t->AllowedSquad, 20);
				memcpy(t->AllowedSquad, name.msg, min(name.len, 19));

				sendPrivate(p, "Allowed squad changed");
			}
			else if (c->check("fgrant"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, name;
				name = c->final;

				Uint32 i = name.firstInstanceOf(':');

				if (i == -1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = name.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				Player *target = NULL;

				_listnode <Player> *parse = playerlist->head;
				while (parse)
				{
					if (name == parse->item->name)
					{
						target = parse->item;
						break;
					}

					parse = parse->next;
				}

				if (target == NULL)
				{
					sendPrivate(p, "The other player must be in the arena");
					return;
				}

				if (TBox.CountOwned(target->name) >= MaxOwnedFreqs)
				{
					sendPrivate(p, "The player already owns too many freqs");
					return;
				}

				memcpy(t->Owner, target->name, 20);

				String s;
				s = "You are now the owner of freq ";
				s += t->Freq;
				sendPrivate(target, s.msg);

				sendPrivate(p, "Freq owner changed");
			}
			else if (c->check("fwelc"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, msg;
				msg = c->final;

				Uint32 i = msg.firstInstanceOf(':');

				if (i == -1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = msg.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				ZeroMemory(t->GreetMessage, 200);
				memcpy(t->GreetMessage, msg.msg, min(msg.len, 199));

				sendPrivate(p, "Freq welcome message changed");
			}
			else if (c->check("finv"))
			{
				if (!*c->final)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				String freq, name;
				name = c->final;

				Uint32 i = name.firstInstanceOf(':');

				if (i == -1)
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				freq = name.split(':');

				if (!isNumeric(freq.msg))
				{
					sendPrivate(p, "Invalid syntax");
					return;
				}

				i = freq.toInteger();

				TeamEntry *t = TBox.FindTeam((Uint16)i);

				if (!t)
				{
					sendPrivate(p, "That freq is not registered");
					return;
				}

				if (!CMPSTR(t->Owner, p->name))
				{
					sendPrivate(p, "You are not the owner of that freq");
					return;
				}

				Player *target = NULL;

				_listnode <Player> *parse = playerlist->head;
				while (parse)
				{
					if (name == parse->item->name)
					{
						target = parse->item;
						break;
					}

					parse = parse->next;
				}

				if (target == NULL)
				{
					sendPrivate(p, "The other player must be in the arena");
					return;
				}

				TBox.AddInvite(t->Freq, target->name);

				String s;
				s = p->name;
				s += " invited you to freq ";
				s += t->Freq;
				s += ". You have ";
				s += InviteExpireSeconds;
				s += " seconds before the invite expires";

				sendPrivate(target, s.msg);

				sendPrivate(p, "Player invited");
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
